searchNodes=[{"doc":"Mnesiac Manager","ref":"Mnesiac.html","title":"Mnesiac","type":"module"},{"doc":"Cluster status","ref":"Mnesiac.html#cluster_status/0","title":"Mnesiac.cluster_status/0","type":"function"},{"doc":"Cluster with a node","ref":"Mnesiac.html#connect/1","title":"Mnesiac.connect/1","type":"function"},{"doc":"Start Mnesia with strict host checking","ref":"Mnesiac.html#init_mnesia/1","title":"Mnesiac.init_mnesia/1","type":"function"},{"doc":"Join to a Mnesia cluster","ref":"Mnesiac.html#join_cluster/1","title":"Mnesiac.join_cluster/1","type":"function"},{"doc":"Is node in Mnesia cluster?","ref":"Mnesiac.html#node_in_cluster?/1","title":"Mnesiac.node_in_cluster?/1","type":"function"},{"doc":"Is running Mnesia node?","ref":"Mnesiac.html#running_db_node?/1","title":"Mnesiac.running_db_node?/1","type":"function"},{"doc":"Running Mnesia nodes","ref":"Mnesiac.html#running_nodes/0","title":"Mnesiac.running_nodes/0","type":"function"},{"doc":"Start Mnesia alone","ref":"Mnesiac.html#start/0","title":"Mnesiac.start/0","type":"function"},{"doc":"This module defines a mnesiac store and contains overridable callbacks.","ref":"Mnesiac.Store.html","title":"Mnesiac.Store","type":"behaviour"},{"doc":"This function is called by mnesiac when it joins a mnesia cluster and data for this store is found on the remote node in the cluster that is being connected to. Default Implementation def copy_store do for type &lt;- [ :ram_copies , :disc_copies , :disc_only_copies ] do value = Keyword . get ( store_options ( ) , type , [ ] ) if Enum . member? ( value , node ( ) ) do :mnesia . add_table_copy ( Keyword . get ( store_options ( ) , :record_name , __MODULE__ ) , node ( ) , type ) end end end","ref":"Mnesiac.Store.html#c:copy_store/0","title":"Mnesiac.Store.copy_store/0","type":"callback"},{"doc":"This function is called by mnesiac either when it has no existing data to use or copy and will initialise a table Default Implementation def init_store do :mnesia . create_table ( Keyword . get ( store_options ( ) , :record_name , __MODULE__ ) , store_options ( ) ) end","ref":"Mnesiac.Store.html#c:init_store/0","title":"Mnesiac.Store.init_store/0","type":"callback"},{"doc":"This function is called by mnesiac when it has detected data for a table on both the local node and the remote node of the cluster it is connecting to. Default Implementation def resolve_conflict ( cluster_node ) do table_name = Keyword . get ( store_options ( ) , :record_name , __MODULE__ ) Logger . info ( fn -&gt; &quot;[mnesiac: \#{ node ( ) } ] \#{ inspect ( table_name ) } : data found on both sides, copy aborted.&quot; end ) :ok end Note : The default implementation for this function is to do nothing.","ref":"Mnesiac.Store.html#c:resolve_conflict/1","title":"Mnesiac.Store.resolve_conflict/1","type":"callback"},{"doc":"This function returns the store's configuration as a keyword list. For more information on the options supported here, see mnesia's documentation. Examples iex&gt; store_options ( ) [ attributes : [ ... ] , index : [ :topic_id ] , disc_copies : [ node ( ) ] ] Note : Defining :record_name in store_options() will set the mnesia table name to the same.","ref":"Mnesiac.Store.html#c:store_options/0","title":"Mnesiac.Store.store_options/0","type":"callback"},{"doc":"Mnesia Store Manager","ref":"Mnesiac.StoreManager.html","title":"Mnesiac.StoreManager","type":"module"},{"doc":"Copy schema","ref":"Mnesiac.StoreManager.html#copy_schema/1","title":"Mnesiac.StoreManager.copy_schema/1","type":"function"},{"doc":"Copy tables","ref":"Mnesiac.StoreManager.html#copy_tables/1","title":"Mnesiac.StoreManager.copy_tables/1","type":"function"},{"doc":"Create tables","ref":"Mnesiac.StoreManager.html#create_tables/0","title":"Mnesiac.StoreManager.create_tables/0","type":"function"},{"doc":"Delete schema copy","ref":"Mnesiac.StoreManager.html#del_schema_copy/1","title":"Mnesiac.StoreManager.del_schema_copy/1","type":"function"},{"doc":"Delete schema","ref":"Mnesiac.StoreManager.html#delete_schema/0","title":"Mnesiac.StoreManager.delete_schema/0","type":"function"},{"doc":"Ensure tables loaded","ref":"Mnesiac.StoreManager.html#ensure_tables_loaded/0","title":"Mnesiac.StoreManager.ensure_tables_loaded/0","type":"function"},{"doc":"This function returns a map of tables and their cookies.","ref":"Mnesiac.StoreManager.html#get_table_cookies/1","title":"Mnesiac.StoreManager.get_table_cookies/1","type":"function"},{"doc":"Init tables","ref":"Mnesiac.StoreManager.html#init_tables/0","title":"Mnesiac.StoreManager.init_tables/0","type":"function"},{"doc":"Mnesia auto clustering made easy! Docs can be found at https://hexdocs.pm/mnesiac . NOTICE: Mnesiac, while stable, is still considered pre 1.0 . This means the API can, and may, change at any time. Please ensure you review the docs and changelog prior to updating. NOTICE: Mnesiac allows a significant amount of freedom with how it behaves. This allows you to customize Mnesiac to suit your needs. However, this also allows for a fair amount of foot gunning. Please ensure you've done your due diligence when using this library, or Mnesia itself for that matter. It isn't a silver bullet, and it shouldn't be treated as one.","ref":"readme.html","title":"Mnesiac","type":"extras"},{"doc":"Simply add mnesiac to your list of dependencies in mix.exs : def deps do [ { :mnesiac , &quot;~&gt; 0.3&quot; } ] end Edit your app's config.exs to add the list of Mnesia stores: config :mnesiac , stores : [ MyApp.ExampleStore , ... ] , schema_type : :disc_copies , # defaults to :ram_copies table_load_timeout : 600_000 # milliseconds, default is 600_000 Then add mnesiac to your supervision tree: EXAMPLE: With libcluster using the Cluster.Strategy.Epmd strategy: ... topology = Application . get_env ( :libcluster , :topologies ) hosts = topology [ :myapp ] [ :config ] [ :hosts ] children = [ { Cluster.Supervisor , [ topology , [ name : MyApp.ClusterSupervisor ] ] } , { Mnesiac.Supervisor , [ hosts , [ name : MyApp.MnesiacSupervisor ] ] } , ... ] ... EXAMPLE: Without libcluster : ... children = [ { Mnesiac.Supervisor , [ [ :&quot;test01@127.0.0.1&quot; , :&quot;test02@127.0.0.1&quot; ] , [ name : MyApp.MnesiacSupervisor ] ] } , ... ] ...","ref":"readme.html#installation","title":"Mnesiac - Installation","type":"extras"},{"doc":"Table creation Create a table store, use Mnesiac.Store , and add it to your app's config.exs. All stores MUST implement its own store_options/0 , which returns a keyword list of store options. There are three optional callbacks which can be implemented: init_store/0 , which allows users to implement custom store initialization logic. Triggered by Mnesiac. copy_store/0 , which allows users to implement a custom call to copy a store. Triggered by Mnesiac. resolve_conflict/1 , which allows a user to implement logic when Mnesiac detects a store with records on both the local and remote Mnesia cluster node. Triggered by Mnesiac. Default is to do nothing. MINIMAL EXAMPLE: defmodule MyApp.ExampleStore do @moduledoc &quot;&quot;&quot; Provides the structure of ExampleStore records for a minimal example of Mnesiac. &quot;&quot;&quot; use Mnesiac.Store import Record , only : [ defrecord : 3 ] @doc &quot;&quot;&quot; Record definition for ExampleStore example record. &quot;&quot;&quot; defrecord ( :example , __MODULE__ , id : nil , topic_id : nil , event : nil ) @typedoc &quot;&quot;&quot; ExampleStore example record field type definitions. &quot;&quot;&quot; @type example :: record ( :example , id : String . t ( ) , topic_id : String . t ( ) , event : String . t ( ) ) @impl true def store_options , do : [ record_name : :example , attributes : example ( ) |&gt; example ( ) |&gt; Keyword . keys ( ) , index : [ :topic_id ] , ram_copies : [ node ( ) ] ] end Clustering If you are using libcluster or another clustering library, ensure that the clustering library starts before mnesiac . That's all, you don't need to do anything else. If you are not using libcluster or similar clustering libraries then: When a node joins to an erlang/elixir cluster, run the Mnesiac.init_mnesia/1 function on the new node . This will initialize and copy the store contents from the other online nodes in the Mnesia cluster.","ref":"readme.html#usage","title":"Mnesiac - Usage","type":"extras"},{"doc":"Ensure you have the proper language versions installed. To do this, an asdf tools file has been provided. Run the following: git clone https://github.com/beardedeagle/mnesiac.git git checkout -b MyFeature asdf install mix local.hex --force mix local.rebar --force mix deps.get --force mix deps.compile --force mix compile --force NOTICE: You can find the asdf tool here .","ref":"readme.html#development","title":"Mnesiac - Development","type":"extras"},{"doc":"Before you run any tests, ensure that you have cleaned up Mnesia: mix purge.db Test results and coverage reports are generated by running the following: mix coveralls.html --trace --slowest 10 --no-start","ref":"readme.html#testing","title":"Mnesiac - Testing","type":"extras"},{"doc":"This library was built standing on the shoulders of giants. A big thanks goes out to Mustafa Turan. The original library this was forked from can be found here: https://github.com/mustafaturan/mnesiam . Happy coding!","ref":"readme.html#notice","title":"Mnesiac - Notice","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changed Changed get_table_cookies/1 and get_table_cookies/2 to utilize table_load_timeout/0 for :rpc.call/5 calls.","ref":"changelog.html#0-3-12-2023-05-06","title":"Changelog - [0.3.12] - 2023-05-06","type":"extras"},{"doc":"Added Added test to ensure get_table_cookies/1 returns error when node is not reachable. Fixed Fixed handling of :badrpc errors in copy_tables/1 and get_table_cookies/1 not being enumerable.","ref":"changelog.html#0-3-11-2023-05-06","title":"Changelog - [0.3.11] - 2023-05-06","type":"extras"},{"doc":"Changed Assert that Mnesiac.init_mnesia/1 is called successfully. Updated dependencies. Updated GitHub repo files. Fixed Updated get_table_cookies/1 to use :local_tables instead of :tables to properly identify table copies that don't exist locally to a given node, closes #84.","ref":"changelog.html#0-3-10-2023-05-04","title":"Changelog - [0.3.10] - 2023-05-04","type":"extras"},{"doc":"Changed Bumped OTP version. Bumped Elixir version. Updated Travis CI integration for new OTP release. Updated dependencies. Updated GitHub repo files.","ref":"changelog.html#0-3-9-2021-02-21","title":"Changelog - [0.3.9] - 2021-02-21","type":"extras"},{"doc":"Changed Moved :mnesia out of extra_applications into included_applications . Bumped OTP version. Updated Travis CI integration for new OTP release. Updated dependencies. Updated GitHub repo files.","ref":"changelog.html#0-3-8-2020-09-01","title":"Changelog - [0.3.8] - 2020-09-01","type":"extras"},{"doc":"Changed Bumped OTP version. Bumped Elixir version. Updated Travis CI integration for new OTP and Elixir releases. Updated dependencies. Updated GitHub repo files.","ref":"changelog.html#0-3-7-2020-07-17","title":"Changelog - [0.3.7] - 2020-07-17","type":"extras"},{"doc":"Added Additional GitHub repo files. Changed Bumped OTP version. Fixed Travis CI integration.","ref":"changelog.html#0-3-6-2020-03-01","title":"Changelog - [0.3.6] - 2020-03-01","type":"extras"},{"doc":"Changed Bumped OTP version. Bumped Elixir version. Updated dependencies.","ref":"changelog.html#0-3-5-2020-02-27","title":"Changelog - [0.3.5] - 2020-02-27","type":"extras"},{"doc":"Fixed Logger crashes in Mnesiac module. copy_table bug, closes #20. Changed Bumped OTP version. Bumped Elixir version. Updated dependencies.","ref":"changelog.html#0-3-4-2019-08-20","title":"Changelog - [0.3.4] - 2019-08-20","type":"extras"},{"doc":"Fixed Apply regression fix to copy_store/0 and resolve_conflict/1 . Docs cleanup.","ref":"changelog.html#0-3-3-2019-02-25","title":"Changelog - [0.3.3] - 2019-02-25","type":"extras"},{"doc":"Fixed Regression that made defining a custom table name impossible.","ref":"changelog.html#0-3-2-2019-02-22","title":"Changelog - [0.3.2] - 2019-02-22","type":"extras"},{"doc":"Added Inch reports. Fixed Misc docs.","ref":"changelog.html#0-3-1-2019-02-21","title":"Changelog - [0.3.1] - 2019-02-21","type":"extras"},{"doc":"Added Distributed testing suite. Implemented store as a macro, with overridable callbacks. Changed Bumped OTP version. Bumped Elixir version. Updated dependencies. Started using keepachangelog.com changelog format. Hex doc improvements. Travis CI improvements.","ref":"changelog.html#0-3-0-2019-02-14","title":"Changelog - [0.3.0] - 2019-02-14","type":"extras"},{"doc":"Added Additional tests. Created .github folder and files. Created badge links. Created dev and test instructions.","ref":"changelog.html#0-2-0-2018-07-30","title":"Changelog - [0.2.0] - 2018-07-30","type":"extras"},{"doc":"Added Initial release.","ref":"changelog.html#0-1-0-2018-07-29","title":"Changelog - [0.1.0] - 2018-07-29","type":"extras"}]